#include <cctype>
#include "validation.h"

#define all(x) begin(x), end(x)

// This program will be called as `output_validator input answer < output`.

// This custom validator accepts the list of flipped cards in any order.

int main(int argc, char *argv[]) {
    std::ifstream in(argv[1]);
    std::ifstream ans(argv[2]);
    OutputValidator v(argc, argv);

    std::string s;
    ans >> s;  // could contain `m` (which we ignore)

    // check correctness in case of "true" or "false"
    if (std::isalpha(s[0])) {
        v.test_string(s);
        v.newline();
        return 0;
    }

    int k;  // number of cards on table
    in >> k >> k;

    // read `flip` from answer
    std::vector<long long> flipAns;
    for (int x; ans >> x; ) flipAns.push_back(x);
    int m = flipAns.size();

    // read `flip` from output
    v.read_integer("m", m, m);
    v.newline();
    std::vector<long long> flipOut = v.read_integers("flip", m, 1, k);

    std::sort(all(flipAns));
    std::sort(all(flipOut));
    v.check(flipAns == flipOut, "`flip` list incorrect");
}
