#include "validation.h"

#define all(x) begin(x), end(x)
using ll = long long;


int main(int argc, char *argv[]) {
    std::ifstream in(argv[1]);
    std::ifstream ans(argv[2]);
    OutputValidator v(argc, argv);

    int n; in >> n;
    std::vector<ll> a(n);
    for (auto& x : a) in >> x;

    if (ans.peek() == 'i') {
        std::string impossible_jury; ans >> impossible_jury;
        assert(impossible_jury == "impossible");
        v.test_string("impossible");
        v.newline();
        return 0;
    }
    auto seq = v.read_integers("construction_sequence", n, 1, n);
    std::ranges::transform(seq, seq.begin(), [](int x) { return x-1; });
    std::vector<bool> used(n);
    for (int x : seq) used[x] = true;
    v.check(std::ranges::all_of(used, [](bool b) { return b; }), "construction sequence is not a permutation of 1..n");

    std::vector<ll> p(n+1);
    std::partial_sum(all(a), p.begin()+1);

    int l = seq[0], r = seq[0];
    for (int i = 1; i < n; ++i) {
        if ((p[r+1] - p[l]) * n > p[n] * (r - l + 1)) v.WA("range [" + std::to_string(l) + ", " + std::to_string(r) + "] has sum above average");
        if (seq[i] == l - 1) --l;
        else if (seq[i] == r + 1) ++r;
        else v.WA("construction sequence is not a contiguous subarray");
    }
}
