import kotlin.math.min
import kotlin.math.pow

val MOD = 9000000000000007L // Closest "round" prime below 2^63/1009

fun mPair(i: Int, j: Int): Int {
    return 5000 * i + j
}

fun main() {
    val word = readln().trim()
    val n = word.length
    val hash = LongArray(5001 * 5001)

    for (i in 0 until n) {
        var curr = (word[i].code - 'a'.code).toLong()
        for (j in i + 1 until n) {
            curr = (curr * 1009 + word[j].code.toLong() - 'a'.code.toLong()) % MOD
            hash[mPair(i, j + 1)] = curr
        }
    }

    var best = n + 1
    for (partLen in 2..n) {
        val counter: MutableMap<Long, Int> = HashMap()
        val nextPos: MutableMap<Long, Int> = HashMap()
        for (i in 0..n - partLen) {
            val h = hash[mPair(i, i + partLen)]
            if (nextPos.getOrDefault(h, 0) > i) continue
            counter.merge(h, 1) { a: Int?, b: Int? -> Integer.sum(a!!, b!!) }
            nextPos[h] = i + partLen
        }
        for (count in counter.values) {
            best = min(best.toDouble(), (n - (partLen - 1) * (count - 1) + 1).toDouble()).toInt()
        }
    }

    println(best)
}

