import java.io.*;
import java.util.*;

public class MaartenListScanner {
    public static void main(String[] args) throws IOException {
        try (BufferedReader reader = new BufferedReader(new InputStreamReader(System.in))) {
            new MaartenListScanner().run(new Scanner(reader));
        }
    }

    private static final long MOD = 9000000000000007L; // Closest "round" prime below 2^63/1009

    public static int mPair(int i, int j) {
        return 5000 * i + j;
    }

    public void run(Scanner sc) throws IOException {
        String word = sc.next();
        int n = word.length();
        long[] hash = new long[5001 * 5001];

        for (int i = 0; i < n; i++) {
            long curr = word.charAt(i) - 'a';
            for (int j = i + 1; j < n; j++) {
                curr = (curr * 1009 + word.charAt(j) - 'a') % MOD;
                hash[mPair(i, j + 1)] = curr;
            }
        }

        int best = n + 1;
        for (int partLen = 2; partLen <= n; partLen++) {
            Map<Long, Integer> counter = new HashMap<>();
            Map<Long, Integer> nextPos = new HashMap<>();
            for (int i = 0; i <= n - partLen; i++) {
                long h = hash[mPair(i, i + partLen)];
                if (nextPos.getOrDefault(h, 0) > i) continue;
                counter.merge(h, 1, Integer::sum);
                nextPos.put(h, i + partLen);
            }
            for (int count : counter.values()) {
                best = Math.min(best, n - (partLen - 1) * (count - 1) + 1);
            }
        }

        System.out.println(best);
    }
}
