import java.util.*;

public class MikeTranscribed {
    static int[] lengths;

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int r = scanner.nextInt();
        int c = scanner.nextInt();
        int q = scanner.nextInt();
        scanner.nextLine();
        char[][] board = new char[r][c];
        for (int i = 0; i < r; i++) {
            board[i] = scanner.nextLine().toCharArray();
        }
        int[] heights = new int[c];
        List<List<Integer>> heightIndices = new ArrayList<>();
        for (int i = 0; i <= r; i++) {
            heightIndices.add(new ArrayList<>());
        }
        for (int h = 0; h < r; h++) {
            for (int w = 0; w < c; w++) {
                heights[w] = board[h][w] == '.' ? heights[w] + 1 : 0;
                heightIndices.get(heights[w]).add(h * c + w);
            }
        }
        int[][] counts = new int[r + 1][c + 1];
        lengths = new int[c + 1];
        Intervals[] rows = new Intervals[r];
        for (int i = 0; i < r; i++) {
            rows[i] = new Intervals(c);
        }
        for (int h = r - 1; h >= 0; h--) {
            for (int p : heightIndices.get(h + 1)) {
                rows[p / c].add(p % c);
            }
            int count = 0, sum = 0;
            for (int w = c; w > 0; w--) {
                counts[h + 1][w] = sum + count + lengths[w];
                count += lengths[w];
                sum += count;
            }
        }
        for (int i = 1; i <= q; ++i){
            int h = scanner.nextInt(), w = scanner.nextInt();
            System.out.println(counts[h][w]);
        }
    }

    static class Intervals {
        private int n;
        private int[] boundary;

        public Intervals(int n) {
            this.n = n;
            this.boundary = new int[n];
            Arrays.fill(this.boundary, -1);
        }

        public void merge(int i) {
            lengths[i - this.boundary[i] + 1]--;
            lengths[this.boundary[i + 1] - i]--;
            lengths[this.boundary[i + 1] - this.boundary[i] + 1]++;
            int temp0 = this.boundary[i];
            int temp1 = this.boundary[i + 1];
            this.boundary[temp1] = temp0;
            this.boundary[temp0] = temp1;
        }

        public void add(int i) {
            this.boundary[i] = i;
            lengths[1]++;
            if (i < this.n - 1 && this.boundary[i + 1] != -1) {
                this.merge(i);
            }
            if (i > 0 && this.boundary[i - 1] != -1) {
                this.merge(i - 1);
            }
        }
    }
}
