import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class RagnarNKTranscribed {
    public static void main(String[] args) throws IOException {
        try (BufferedReader reader = new BufferedReader(new InputStreamReader(System.in))) {
            new RagnarNKTranscribed().run(new Scanner(reader));
        }
    }

    public void run(Scanner sc) throws IOException {
        int n = sc.nextInt(), k = sc.nextInt();
        int[] travelDay = new int[n], period = new int[k], days = new int[k];
        long[] fare = new long[n], cost = new long[k];
        for (int i = 0; i < n; i++) {
            travelDay[i] = sc.nextInt();
            fare[i] = sc.nextInt();
        }
        for (int i = 0; i < k; i++) {
            period[i] = sc.nextInt();
            days[i] = sc.nextInt();
            cost[i] = sc.nextInt();
        }

        // Last ride on/before given day.
        int[] lastride = new int[2000001];
        Arrays.fill(lastride, n - 1);
        for (int i = 0; i < n - 1; i++) {
            for (int d = travelDay[i]; d < travelDay[i + 1]; d++)
                lastride[d] = i;
        }

        // Cost of everything before ride i.
        long[] dp = new long[n + 1];
        Arrays.fill(dp, 10000000000L);
        dp[0] = 0;

        for (int i = 0; i < n; i++) {
            long c = dp[i];
            // Pay for i+1:
            dp[i + 1] = min(dp[i + 1], c + fare[i]);
            // Try each of the discount cards, starting with rides[i].
            int startday = travelDay[i];
            for (int j = 0; j < k; j++) {
                // Can do at most `days[j]` rides.
                int h1 = i + days[j];
                // Can span at most `period[j]` days.
                int h2 = lastride[startday + period[j] - 1] + 1;
                int h = min(h1, h2);
                dp[h] = min(dp[h], c + cost[j]);
            }
        }
        System.out.println(dp[n]);
    }
}
