#!/usr/bin/env python3
from collections import deque

n, k = map(int, input().split())
deck = input().split()
table = input().split()
D, L = input().split()

legal, illegal = [], []
for l, d in deck:
    (illegal if l != L and d == D else legal).append(l+d)

if not illegal:
    exit(print("true"))

# construct bipartite graph for matching
sizeLeft = len(legal)
source = sizeLeft + k
sink = source + 1
graph = [{} for _ in range(sink + 1)]
for i, (l, d) in enumerate(legal):
    graph[source][i] = 1
    for j, x in enumerate(table):
        if l == x or d == x:
            graph[i][j + sizeLeft] = 1
for j in range(k):
    graph[j + sizeLeft][sink] = 1

# !!! early return (only tested on slowest submission, i.e., this one)
if sum(map(bool, graph[:sizeLeft])) < k:
    exit(print("false"))

# Edmonds-Karp
flow = 0
while True:
    par = [-1] * len(graph)
    par[source] = source
    q = deque([source])

    while q:
        x = q.popleft()
        for y, c in graph[x].items():
            if par[y] == -1:
                par[y] = x
                if y == sink: q.clear(); break
                q.append(y)

    if par[sink] == -1: break

    flow += 1
    y = sink
    while y != source:
        p = par[y]
        graph[p][y] -= 1
        if graph[p][y] <= 0: graph[p].pop(y)
        graph[y][p] = 1 + graph[y].get(p, 0)
        y = p

if flow != k:
    exit(print("false"))

check = set(l for l, _ in illegal)
flip = [i for i, x in enumerate(table) if x == D or x in check]

if flip:
    print(len(flip))
    print(' '.join(str(i+1) for i in flip))
else:
    print("true")
