#include <algorithm>
#include <cassert>
#include <iostream>
#include <string>
#include <vector>

struct team {
    int i;  // initial rank, 0-based
    std::string status;
};

int count(const std::string &s, char c) {
    return std::count(s.begin(), s.end(), c);
}

int main() {
    int n, r;
    std::cin >> n >> r >> r;  // ignore `m`
    r--;

    std::vector<team> teams(n);
    for (int i = 0; i < n; i++) {
        teams[i].i = i;
        std::cin >> teams[i].status;
    }

    // note: this submission does not break early (i.e. if we're past team `r` such that its rank is fixed)
    int i = n-1;
    for (std::string shout; std::cin >> shout >> shout; ) {
        // find next pending submission
        int j;
        while (true) {
            assert(i >= 0);
            j = teams[i].status.find('P');
            if (j == std::string::npos) i--; else break;
        }

        // "reveal" pending submission (we don't care whether it's "A" or "R")
        team t = teams[i];
        t.status[j] = 'x';

        // if crowd shouts "Aaayyy", move `t` up
        const int rise = std::max(0, count(shout, 'y') - 3);
        assert(i - rise >= 0);
        for (int i2 = i; i2 > i - rise; i2--) teams[i2] = teams[i2-1];
        teams[i - rise] = t;
    }

    for (int i = 0; i < n; i++) {
        if (teams[i].i == r) {
            std::cout << i+1 << std::endl;
            return 0;
        }
    }
    assert(false);
}
