private class BIT(val n: Int) {
    private val x = LongArray(n)

    fun add(pos:Int, value: Long) {
        var ppos = pos
        while (ppos < n) {
            x[ppos] += value
            ppos = ppos or (ppos + 1)
        }
    }

    fun get(pos: Int): Long {
        var ans: Long = 0
        var ppos = pos
        while (ppos != -1) {
            ans += x[ppos]
            ppos = (ppos and (ppos + 1)) - 1
        }
        return ans
    }
    fun get(l:Int, r:Int) = get(r - 1) - get(l - 1)
}

data class Operation(val size: Int, val change: Int)

fun getOps(d: IntArray, ops: List<MutableList<Operation>>) {
    val next = IntArray(d.size + 2) { it + 1 }
    val prev = IntArray(d.size + 2) { it - 1 }
    for (i in d.indices.sortedByDescending { d[it] }) {
        val lf = prev[i + 1] - 1
        val rg = next[i + 1] - 1
        next[prev[i+1]] = next[i+1]
        prev[next[i+1]] = prev[i+1]
        ops[d[i]+1].add(Operation(rg - lf - 1, -1))
        ops[d[i]+1].add(Operation(i - lf - 1, +1))
        ops[d[i]+1].add(Operation(rg - i - 1, +1))
    }
}


fun main() {
    val (n, m, q) = readInts()
    val d = List(n) { readln() }
    val down = IntArray(m)
    val ops = List(n+2) { mutableListOf<Operation>() }
    ops[0].add(Operation(m, +n))
    for (i in n - 1 downTo 0) {
        for (j in 0 until m) {
            if (d[i][j] == '.') {
                down[j] = down[j] + 1
            } else {
                down[j] = 0
            }
        }
        getOps(down, ops)
    }
    val qs = List(q) { readInts() }.withIndex().sortedBy { it.value[0] }
    val b1 = BIT(m + 1)
    val b2 = BIT(m + 1)
    var ptr = 0
    val ans = LongArray(q)
    for ((id, q) in qs) {
        while (ptr <= q[0]) {
            for (op in ops[ptr]) {
                b1.add(op.size, op.change.toLong())
                b2.add(op.size, op.size.toLong() * op.change)
            }
            ptr++
        }
        ans[id] = b2.get(q[1], m+1) - b1.get(q[1], m+1) * (q[1] - 1)
    }
    println(ans.joinToString("\n"))
}

private fun readInt() = readln().toInt()
private fun readLongs() = readStrings().map { it.toLong() }
private fun readStrings() = readln().split(" ")
private fun readInts() = readStrings().map { it.toInt() }