import java.util.*;
import java.io.*;
import java.math.*;

public class jeroen
{
	public static void main(String[] args) throws Exception
	{
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		String[] ps = in.readLine().split(" ");
		int n = Integer.valueOf(ps[0]);
		int m = Integer.valueOf(ps[1]);
		double[] p = new double[n];
		ps = in.readLine().split(" ");
		for(int i = 0; i < n; i++)
			p[i] = Double.valueOf(ps[i]);
		Scc scc = new Scc(n);
		int[] a = new int[m];
		int[] b = new int[m];
		for(int i = 0; i < m; i++) {
			ps = in.readLine().split(" ");
			a[i] = Integer.valueOf(ps[0]) - 1;
			b[i] = Integer.valueOf(ps[1]) - 1;
			scc.AddEdge(b[i], a[i]);
		}

		// Compute the probability per strongly connected component
		int c = scc.FindComponents();
		double[] pc = new double[c];
		for(int i = 0; i < c; i++) pc[i] = 1;
		for(int i = 0; i < n; i++)
			pc[scc.component[i]] *= 1 - p[i];

		// Now the components form a tree, and due to how the SCC algorithm works we can
		// visit them in component numbering order
		HashSet<Integer>[] cdeps = new HashSet[c];
		for(int i = 0; i < c; i++) cdeps[i] = new HashSet<Integer>();
		for(int i = 0; i < m; i++) {
			int ca = scc.component[a[i]];
			int cb = scc.component[b[i]];
			if(ca != cb)
				cdeps[ca].add(cb);
		}
		for(int i = 0; i < c; i++)
			for(int d : cdeps[i])
				pc[i] *= pc[d];

		// Simply find the maximum
		double ans = 0;
		for(int i = 0; i < c; i++)
			ans = Math.max(ans, pc[i]);
		System.out.println(ans);
	}

	static class Scc {
		public int n;
		public int[] component;
		public ArrayList<Integer>[] Neighbors, NeighborsR;
		private int[] order;
		private int order_num, actnum;

		public Scc(int n)
		{
			this.n = n;
			Neighbors = new ArrayList[n];
			NeighborsR = new ArrayList[n];
			for (int i = 0; i < n; i++) {
				Neighbors[i] = new ArrayList<Integer>();
				NeighborsR[i] = new ArrayList<Integer>();
			}
		}

		public void AddEdge(int i, int j)
		{
			Neighbors[i].add(j);
			NeighborsR[j].add(i);
		}

		public int FindComponents()
		{
			component = new int[n];
			order = new int[n];
			order_num = 0;

			for (int i = 0; i < n; i++)
				Dfs1(i);

			actnum = 0;
			for (int i = n - 1; i >= 0; i--) {
				if (component[order[i]] == -1) {
					Dfs2(order[i]);
					actnum++;
				}
			}
			return actnum;
		}
		
		private void Dfs1(int i) {
			if (component[i] != 0) return;
			component[i] = -1;
			for (int adj : Neighbors[i])
				Dfs1(adj);
			order[order_num++] = i;
		}
		
		private void Dfs2(int i) {
			if (component[i] != -1) return;
			component[i] = actnum;
			for (int adj : NeighborsR[i])
				Dfs2(adj);
		}
	}
}
