import java.util.*;
import java.io.*;
import java.math.*;

public class jeroen
{
	public static void main(String[] args) throws Exception
	{
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		String[] ps = in.readLine().split(" ");
		int n = Integer.valueOf(ps[0]);
		int k = Integer.valueOf(ps[1]);
		String[] orders = in.readLine().split(" ");
		String[] pinned = in.readLine().split(" ");
		ps = in.readLine().split(" ");
		char ct = ps[0].charAt(0);
		char cm = ps[1].charAt(0);

		// Use a max flow to make a bipartite matching between tickets and orders
		// from the computer
		MaxFlow mf = new MaxFlow(n + k + 2);
		int source = n + k;
		int sink = source + 1;
		for(int i = 0; i < n; i++)
			mf.addEdge(source, i, 1);
		for(int j = 0; j < k; j++)
			mf.addEdge(n + j, sink, 1);
		boolean[] exclude = new boolean[127];
		for(int i = 0; i < n; i++) {
			// Exclude orders that would disprove the claim
			if(orders[i].charAt(0) != cm && orders[i].charAt(1) == ct) {
				exclude[orders[i].charAt(0)] = true;
				exclude[orders[i].charAt(1)] = true;
				continue;
			}

			for(int j = 0; j < k; j++) {
				char p = pinned[j].charAt(0);
				if(orders[i].charAt(0) == p || orders[i].charAt(1) == p)
					mf.addEdge(i, n + j, 1);
			}
		}

		// If we can't find a matching, the statement must be false
		if(k != mf.maxFlow(source, sink)) {
			System.out.println("false");
			return;
		}

		// All pinned up items for excluded cards need to be flipped
		ArrayList<Integer> toflip = new ArrayList<Integer>();
		for(int i = 0; i < k; i++)
			if(exclude[pinned[i].charAt(0)])
				toflip.add(i+1);

		// If there is nothing to flip, the claim must be true
		if(toflip.isEmpty()) {
			System.out.println("true");
			return;
		}

		// Print the answer
		System.out.println(toflip.size());
		for(int i : toflip)
			System.out.print(i + " ");
		System.out.println();
	}

	static class MaxFlow {
		public int Nodes;
		public List<Edge>[] Edges;

		public class Edge
		{
			public int from, to;
			public long cap, flow;
			public Edge rev;

			public Edge(int f, int t, long ca)
			{
				from = f;
				to = t;
				cap = ca;
				flow = 0;
				rev = null;
			}
		}

		public MaxFlow(int Nodes)
		{
			this.Nodes = Nodes;
			Edges = new List[Nodes];
			for (int i = 0; i < Nodes; i++)
				Edges[i] = new ArrayList<>();
		}

		public void addEdge(int From, int To, long Cap)
		{
			Edges[From].add(new Edge(From, To, Cap));
		}

		public int maxFlow(int From, int To)
		{
			Edge[] parent = new Edge[Nodes];
			long[] cap = new long[Nodes];
			boolean changed;
			int Cap = 0;
			while (true) {
				boolean[] done = new boolean[Nodes];
				done[From] = true;
				cap[From] = Long.MAX_VALUE;
				do {
					changed = false;
					for (int i = 0; i < Nodes; i++) {
						if (!done[i]) continue;
						for (Edge e : Edges[i]) {
							if (e.cap > e.flow && !done[e.to]) {
								changed = done[e.to] = true;
								parent[e.to] = e;
								cap[e.to] = Math.min(cap[i], e.cap - e.flow);
							}
						}
					}
				} while (changed && !done[To]);

				if (!done[To])
					return Cap;

				Cap += cap[To];

				int j = To;
				while (j != From) {
					if (parent[j].rev == null) {
						parent[j].rev = new Edge(parent[j].to, parent[j].from, 0);
						parent[j].rev.rev = parent[j];
						Edges[parent[j].to].add(parent[j].rev);
					}
					parent[j].flow += cap[To];
					parent[j].rev.flow -= cap[To];
					j = parent[j].from;
				}
			}
		}
	}
}
