import java.util.*;
import java.io.*;
import java.math.*;

public class jeroen
{
	public static void main(String[] args) throws Exception
	{
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		int n = Integer.valueOf(in.readLine());
		int[] a = new int[n];
		String[] ps = in.readLine().split(" ");
		for(int i = 0; i < n; i++)
			a[i] = Integer.valueOf(ps[i]);

		Avg avg = new Avg();
		for(int i = 0; i < n; i++)
			avg = avg.add(a[i]);

		// Work backwards, every time remove a valid prefix or suffix
		int i = 0;
		int j = n - 1;
		Avg remaining = avg;
		ArrayList<Integer> ret = new ArrayList<Integer>();
		while(i <= j) {
			boolean changed = false;

			// Find prefix with a higher avg than the global avg,
			// which means working backwards it could have been safely removed.
			boolean changedl;
			do {
				changedl = false;
				Avg avgl = new Avg();
				avgl = avgl.add(a[i]);
				int k = i + 1;
				boolean okl = true;
				while(k <= j && avgl.compareTo(avg) < 0) {
					if(remaining.subtract(avgl).compareTo(avg) > 0) {
						okl = false;
						break;
					}
					avgl = avgl.add(a[k]);
					k++;
				}
				if(okl) {
					remaining = remaining.subtract(avgl);
					for(int l = i; l < k; l++)
						ret.add(l+1);
					i = k;
					changed = changedl = true;
				}
			} while(i <= j && changedl);

			if(i > j) break;

			// Similar for suffix
			boolean changedr;
			do {
				changedr = false;
				Avg avgr = new Avg();
				avgr = avgr.add(a[j]);
				int k = j - 1;
				boolean okr = true;
				while(k >= i && avgr.compareTo(avg) < 0) {
					if(remaining.subtract(avgr).compareTo(avg) > 0) {
						okr = false;
						break;
					}
					avgr = avgr.add(a[k]);
					k--;
				}
				if(okr) {
					remaining = remaining.subtract(avgr);
					for(int l = j; l > k; l--)
						ret.add(l+1);
					j = k;
					changed = changedr = true;
				}
			} while(i <= j && changedr);

			// Nothing removed, it's not working out
			if(!changed) {
				System.out.println("impossible");
				return;
			}
		}

		// The answer was constructed backwards, so undo that
		Collections.reverse(ret);
		for(int x : ret)
			System.out.print(x + " ");
		System.out.println();
	}

	static class Avg implements Comparable<Avg> {
		public long n, d;

		public Avg() {
			this.n = 0;
			this.d = 0;
		}

		public Avg(long n, long d) {
			this.n = n;
			this.d = d;
		}

		public Avg add(long a) {
			return new Avg(this.n + a, this.d + 1);
		}

		public Avg subtract(Avg other) {
			return new Avg(n - other.n, d - other.d);
		}

		public int compareTo(Avg other) {
			// (n/d) < (other.n/other.d)
			// n*other.d < other.n*d
			return Long.compare(n * other.d, other.n * d);
		}
	}
}
