private class Average(val sum: Long, val count: Int) : Comparable<Average> {
    override fun compareTo(o: Average) = (sum * o.count).compareTo(count * o.sum)
    operator fun plus(o: Average) = Average(sum + o.sum, count + o.count)
    operator fun minus(o: Average) = Average(sum - o.sum, count - o.count)
}

fun main() {
    val n = readInt()
    val a = readLongs().map { Average(it, 1) }
    val target = a.reduce(Average::plus)
    var remaining = target

    val ans = mutableListOf<Int>()
    var l = 0
    var r = n-1
    var lastSide = true

    fun take(side: Boolean) : Boolean {
        var s = Average(0, 0)
        var pos = if (side) l else r
        val dir = if (side) 1 else -1
        do {
            if (remaining - s > target) return false
            s += a[pos]
            pos += dir
        } while (pos in l..r && s < target)
        repeat(s.count) {
            ans.add(if (side) l++ else r--)
        }
        remaining -= s
        lastSide = side
        return true
    }

    while (l <= r) {
        if (!take(lastSide) && !take(!lastSide)) {
            println("impossible")
            return
        }
    }
    println(ans.reversed().joinToString(" ") { (it+1).toString() })
}


private fun readInt() = readln().toInt()
private fun readLongs() = readStrings().map { it.toLong() }
private fun readStrings() = readln().split(" ")
private fun readInts() = readStrings().map { it.toInt() }