#include <iostream>
#include <ext/pb_ds/assoc_container.hpp>
#include <vector>

typedef long long ll;

using namespace std;
using namespace __gnu_pbds;

const ll MOD = 9000000000000007L; // Closest "round" prime below 2^63/1009

int m_pair(int i, int j) {
    return 5000 * i + j;
}

int main() {
    string word;
    cin >> word;
    int n = word.length();

    vector<ll> hash(5001 * 5001); // Rolling hash ftw!
    for (int i = 0; i < n; i++) {
        ll curr = word[i] - 'a';
        for (int j = i + 1; j < n; j++) {
            curr = (curr * 1009 + word[j] - 'a') % MOD;
            hash[m_pair(i, j + 1)] = curr;
        }
    }

    int best = n + 1;
    gp_hash_table<ll, int> counter, next_pos;
    for (int part_len = 2; part_len < n; part_len++) {
		counter.clear();
		next_pos.clear();
        for (int i = 0; i <= n - part_len; i++) {
            ll h = hash[m_pair(i, i + part_len)];
            if (next_pos[h] > i) continue;
            counter[h]++;
            next_pos[h] = i + part_len;
        }
        for (auto [_, count] : counter) {
            best = min(best, n - (part_len - 1) * (count - 1) + 1);
        }
    }

    cout << best << endl;
}
