
#include <iostream>
#include <vector>
#include <string>

std::vector<int> lengths;

struct intervals{
	int n;
	std::vector<int> boundary;
	intervals(int n_) : n(n_), boundary(n_, -1) {}
	void merge(int i){
		--lengths[i - boundary[i] + 1];
		--lengths[boundary[i + 1] - i];
		++lengths[boundary[i + 1] - boundary[i] + 1];
		int temp = boundary[i + 1];
		boundary[boundary[i + 1]] = boundary[i];
		boundary[boundary[i]] = temp;
	}
	void add(int i){
		boundary[i] = i;
		++lengths[1];
		if (i < n - 1 && boundary[i + 1] != -1) merge(i);
		if (i > 0 && boundary[i - 1] != -1) merge(i - 1);
	}
};

int main(){
	int r, c, q;
	std::cin >> r >> c >> q;
	std::vector<std::string> board(r);
	for (int h = 0; h < r; ++h) std::cin >> board[h];
	std::vector<int> heights(c);
	std::vector<std::vector<std::pair<int, int>>> height_indices(r + 1);
	for (int h = 0; h < r; ++h) for (int w = 0; w < c; ++w){
		heights[w] = board[h][w] == '.' ? heights[w] + 1 : 0;
		height_indices[heights[w]].push_back({h, w});
	}
	std::vector<std::vector<int>> counts(r + 1, std::vector<int>(c + 1));
	lengths = std::vector<int>(c + 1);
	std::vector<intervals> rows(r, c);
	for (int h = r; h > 0; --h){
		for (std::pair<int, int> &p : height_indices[h]) rows[p.first].add(p.second);
		for (int w = c, count = 0, sum = 0; w > 0; --w) counts[h][w] = sum += count += lengths[w];
	}
	for (int i = 1; i <= q; ++i){
	    int h, w;
        std::cin >> h >> w;
		std::cout << counts[h][w] << '\n';
	}
    return 0;
}
