
#include <iostream>
#include <vector>
#include <string>

int main(){
	int r, c, q;
	std::cin >> r >> c >> q;
	std::vector<std::string> board(r);
	for (int h = 0; h < r; ++h) std::cin >> board[h];
    
    std::vector<int> height_counts(r + 1);
    for (int w = 0; w < c; ++w){
        int height = 0;
        for (int h = 0; h < r; ++h){
            height = (height + 1) * (board[h][w] == '.');
            ++height_counts[height];
        }
    }
	std::vector<std::vector<std::pair<int, int>>> height_locations(r + 1);
    std::vector<int> last_index(r + 1, -1);
    for (int h = 0; h <= r; ++h) height_locations[h] = std::vector<std::pair<int, int>>(height_counts[h]);
    for (int w = 0; w < c; ++w){
        int height = 0;
        for (int h = 0; h < r; ++h){
            height = (height + 1) * (board[h][w] == '.');
            height_locations[height][++last_index[height]] = std::pair<int, int>(h, w + 1);
        }
    }
    
	std::vector<std::vector<int>> counts(r + 1, std::vector<int>(c + 1));
	std::vector<int> lengths = std::vector<int>(c + 1);
	std::vector<std::vector<int>> rows(r, std::vector<int>(c + 2));
	for (int h = r; h > 0; --h){
		for (std::pair<int, int> &p : height_locations[h]){
            --lengths[rows[p.first][p.second - 1]];
            --lengths[rows[p.first][p.second + 1]];
            ++lengths[rows[p.first][p.second - rows[p.first][p.second - 1]] = rows[p.first][p.second + rows[p.first][p.second + 1]] = rows[p.first][p.second - 1] + rows[p.first][p.second + 1] + 1];
        }
		for (int w = c, count = 0, sum = 0; w > 0; --w) counts[h][w] = sum += count += lengths[w];
	}
	for (int i = 1; i <= q; ++i){
	    int h, w;
        std::cin >> h >> w;
		std::cout << counts[h][w] << std::endl;
	}
    return 0;
}
