#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n, k;
    cin >> n >> k;
    vector<long long> travelDay(n), fare(n), period(k), days(k), cost(k);
    for(int i = 0; i < n; i++) {
        cin >> travelDay[i] >> fare[i];
    }
    for(int i = 0; i < k; i++) {
        cin >> period[i] >> days[i] >> cost[i];
    }

    // NOTE: This binary searches the last ride.
    // Last ride on/before given day.
    vector<long long> lastride(2000001, n - 1);
    for(int i = 0; i < n - 1; i++) {
        for(long long d = travelDay[i]; d < travelDay[i + 1]; d++) lastride[d] = i;
    }

    // Cost of everything before ride i.
    vector<long long> dp(n + 1, 10000000000L);
    dp[0] = 0;

    for(int i = 0; i < n; i++) {
        long long c = dp[i];
        // Pay for i+1:
        dp[i + 1] = min(dp[i + 1], c + fare[i]);
        // Try each of the discount cards, starting with rides[i].
        long long startday = travelDay[i];
        for(int j = 0; j < k; j++) {
            // Can do at most `days[j]` rides.
            int h1 = i + days[j];
            // Can span at most `period[j]` days.

            int goal = startday + period[j] - 1;
            int ll   = i;
            int hh   = n - 1;
            while(ll < hh) {
                int mm = (ll + hh + 1) / 2;
                if(travelDay[mm] <= goal) {
                    ll = mm;
                } else {
                    hh = mm - 1;
                }
            }

            int h2 = ll + 1;
            int h  = min(h1, h2);
            dp[h]  = min(dp[h], c + cost[j]);
        }
    }
    cout << dp[n] << endl;
}
