#!/usr/bin/env python3

n, k = map(int, input().split())
rides = [list(map(int, input().split())) for i in range(n)]
discounts = [list(map(int, input().split())) for i in range(k)]

# Last ride on/before given day.
lastride = [n - 1] * 2000001
for i in range(n - 1):
    a1 = rides[i][0]
    a2 = rides[i + 1][0]
    for d in range(a1, a2):
        lastride[d] = i


# Cost of everything before ride i.
dp = [10000000000] * (n + 1)
dp[0] = 0

for i in range(n):
    cost = dp[i]
    # Pay for i+1:
    dp[i + 1] = min(dp[i + 1], cost + rides[i][1])
    # Try each of the discount cards, starting with rides[i].
    startday = rides[i][0]
    for d, t, p in discounts:
        # Can do at most t rides.
        j1 = i + t
        # Can span at most d days.
        j2 = lastride[startday + d - 1] + 1
        j = min(j1, j2)
        dp[j] = min(dp[j], cost + p)
print(dp[n])
