#include <algorithm>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <queue>
#include <vector>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> ii;
typedef vector<ll> vi;
typedef vector<vi> vvi;
typedef vector<ii> vii;

#define x first
#define y second
#define pb push_back
#define eb emplace_back
#define rep(i,a,b) for(auto i=(a); i<(b); ++i)
#define REP(i,n) rep(i,0,n)
#define all(v) (v).begin(), (v).end()
#define rs resize
#define DBG(x) cerr << __LINE__ << ": " << #x << " = " << (x) << endl

const ld PI = acos(-1.0);
template<class T> using min_queue =
priority_queue<T, vector<T>, greater<T>>;
template<class T> int sz(const T &x) {
    return (int) x.size(); // copy the ampersand(&)!
}

template<class T> ostream& operator<<(ostream &os, vector<T> &v) {
    os << "\n[";
    for(T &x : v) os << x << ',';
    return os << "]\n";
}

struct pairhash {
    public:
    template<typename T1, typename T2>
    size_t operator()(const pair<T1, T2> &p) const {
        size_t lhs = hash<T1>()(p.x);
        size_t rhs = hash<T2>()(p.y);
        return lhs ^ (rhs+0x9e3779b9+(lhs<<6)+(lhs>>2));
    }
};

void run() {
    ll n, m;
    cin >> n >> m;
    vii A(n);
    vi P(m);
    for (ll i = 0; i < n; i++) {
        ll s;
        cin >> s;
        A[i] = {-s, i+1};
    }
    for (ll i = 0; i < m; i++) {
        cin >> P[i];
    }
    sort(all(A));

    vvi R(m);
    vi S(m, 0);
    for (ii a : A) {
        ll s = -a.x;
        ll bi = -1;
        ll bp = 0, bs = 1;
        for (ll i = 0; i < m; i++) {
            if (P[i]*bs > bp*(S[i]+s)) {
                bi = i;
                bp = P[i];
                bs = S[i]+s;
            }
        }
        R[bi].pb(a.y);
        S[bi] += s;
    }

    for (vi r : R) {
        cout << r.size() << " ";
        for (ll a : r) {
            cout << a << " ";
        }
        cout << endl;
    }
}

signed main() {
    // DON'T MIX "scanf" and "cin"!
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout << fixed << setprecision(20);
    run();
    return 0;
}
