#!/usr/bin/env python3

# Idea: bottom-up dynamic programming, where
#     cost[i] := total cost of rides 0, ..., i-1; disregarding not-fully-used multi-ride tickets.
# Last day is special; it *does* include not-fully-used multi-ride tickets

# This solution uses binary search to look up the index of the last precious trip for a give
# date, for a total running time of O(n * k * log n); this is wasteful and can be replaced
# by a linear scan through the trip dates.

# Works in Python 3.10 (because it uses the key argument to bisect_right)


(n, k), bir = map(int, input().split()), __import__("bisect").bisect_right
T, P = (tuple(tuple(map(int, input().split())) for _ in range(q)) for q in (n, k))

# Initially the cost array "uses no discounts"
C = [0] + [sum(f for (_, f) in T)] * n

for i, (t, f) in enumerate(T):
    C[i + 1] = min(C[i + 1], C[i] + f)
    for p, d, c in P: C[j] = min(C[j := min(i + d, bir(T, t + p - 1, key=lambda t: t[0]))], C[i] + c)
print(C[n])
