#include <iostream>
#include <vector>
#include <functional>
#include <algorithm>
#include <numeric>
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) begin(x), end(x)

using namespace std;
using ll = long long;

struct avg {
    ll sum, cnt;
    avg() : sum(0), cnt(0) {}
    avg(ll sum) : sum(sum), cnt(1) {}
    avg(ll sum, ll cnt) : sum(sum), cnt(cnt) {}
    auto operator<=>(const avg& o) const {
        return double(sum) / cnt <=> double(o.sum) / o.cnt;
    }
    auto operator+(const avg& o) const {
        return avg{sum + o.sum, cnt + o.cnt};
    }
    auto operator+=(const avg& o) {
        return *this = *this + o;
    }
    auto operator-(const avg& o) const {
        return avg{sum - o.sum, cnt - o.cnt};
    }
    auto operator-=(const avg& o) {
        return *this = *this - o;
    }
};

int main() {
    cin.tie(0)->sync_with_stdio(0);

    int n; cin >> n;
    vector<ll> a(n);
    for (auto& x : a) cin >> x;

    avg target{reduce(all(a)), n};
    avg cur = target;

    vector<ll> seq;
    function<bool(int&, int&, bool, avg)> take = [&](int &l, int &r, bool left, avg s) {
        if (cur > target) return false;
        if ((s.cnt > 0 && s >= target) || l > r) return true;
        int i = left ? l : r;
        cur -= a[i];
        if (left) l++;
        else r--;
        bool ok = take(l, r, left, s + a[i]);
        if (ok) seq.push_back(i);
        else {
            cur += a[i];
            if (left) l--;
            else r++;
        }
        return ok;
    };

    int l = 0, r = n-1;
    bool left = true;
    while (l <= r) {
        auto last = seq.size();
        if (take(l, r, left, avg())) reverse(seq.begin() + last, seq.end());
        else if (take(l, r, !left, avg())) reverse(seq.begin() + last, seq.end()), left = !left;
        else {
            cout << "impossible\n";
            return 0;
        }
    }
    ranges::reverse(seq);
    rep(i, n) cout << seq[i]+1 << " \n"[i == n-1];
}
