#include <iostream>
#include <vector>
#include <functional>
#include <algorithm>
#include <numeric>

#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) begin(x), end(x)

using namespace std;
using ll = long long;

struct avg {
    ll sum, cnt;
    avg() : sum(0), cnt(0) {}
    avg(ll sum) : sum(sum), cnt(1) {}
    avg(ll sum, ll cnt) : sum(sum), cnt(cnt) {}
    auto operator<=>(const avg& o) const {
        return sum * o.cnt <=> cnt * o.sum;
    }
    auto operator+(const avg& o) const {
        return avg{sum + o.sum, cnt + o.cnt};
    }
    auto operator+=(const avg& o) {
        return *this = *this + o;
    }
    auto operator-(const avg& o) const {
        return avg{sum - o.sum, cnt - o.cnt};
    }
    auto operator-=(const avg& o) {
        return *this = *this - o;
    }
};

int main() {
    cin.tie(0)->sync_with_stdio(0);

    int n; cin >> n;
    vector<ll> a(n);
    for (auto& x : a) cin >> x;

    avg target{reduce(all(a)), n};
    avg cur = target;

    vector<int> seq;
    int l = 0, r = n-1;
    function<bool(bool)> take = [&](bool side) {
        std::vector<int> sub;
        int ml = l, mr = r;
        avg s;
        avg mcur = cur;
        while (true) {
            if (mcur > target) return false;
            if ((s.cnt > 0 && s >= target) || ml > mr) {
                seq.insert(seq.end(), all(sub));
                l = ml, r = mr, cur = mcur;
                return true;
            }
            int i = side ? ml : mr;
            mcur -= a[i];
            s += a[i];
            if (side) ml++;
            else mr--;
            sub.push_back(i);
        }
    };

    bool side = true;
    while (l <= r) {
        if (take(side));
        else if (take(!side)) side = !side;
        else {
            cout << "impossible\n";
            return 0;
        }
    }
    ranges::reverse(seq);
    rep(i, n) cout << seq[i]+1 << " \n"[i == n-1];
}
