#include <algorithm>
#include <numeric>
#include <iostream>
#include <vector>
#include <iomanip>
#define double long double
#define rep(i, a, b) for (int i = (a); i < (b); i++)
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)size(x)

using namespace std;
using vi = vector<int>;
using vvi = vector<vi>;
using vd = vector<double>;

vi val, comp, z, cont;
int Time, ncomps;
template<class G, class F> int dfs(int j, G& g, F& f) {
    int low = val[j] = ++Time, x; z.push_back(j);
    for (auto e : g[j]) if (comp[e] < 0)
            low = min(low, val[e] ?: dfs(e,g,f));

    if (low == val[j]) {
        do {
            x = z.back(); z.pop_back();
            comp[x] = ncomps;
            cont.push_back(x);
        } while (x != j);
        f(cont); cont.clear();
        ncomps++;
    }
    return val[j] = low;
}
template<class G, class F> void scc(G& g, F f) {
    int n = sz(g);
    val.assign(n, 0); comp.assign(n, -1);
    Time = ncomps = 0;
    rep(i,0,n) if (comp[i] < 0) dfs(i, g, f);
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin.exceptions(cin.failbit);

    int n, m; cin >> n >> m;
    vd p(n); rep(i,0,n) cin >> p[i];

    vvi g(n);
    rep(i,0,m) {
        int a, b; cin >> a >> b;
        --a, --b;
        g[a].push_back(b);
    }

    double ans = -1/.0;
    scc(g, [&](vi& c) {
        for (auto x : c) for (auto y : g[x]) if (comp[y] != comp[x]) return;
        ans = max(ans, accumulate(all(c), (double)1.0, [&](double a, int b) { return a * (1-p[b]); }));
    });

    cout << setprecision(20) << ans << '\n';

    return 0;
}