#include <iostream>
#include <vector>
#include <random>
#include <chrono>
#include <numeric>

#define rep(i, a, b) for (int i = (a); i < (b); i++)
#define all(x) (x).begin(), (x).end()
using namespace std;

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin.exceptions(cin.failbit);

    int n, m; cin >> n >> m;
    vector<int> p(m), s(n);

    rep(i, 0, n) cin >> s[i];
    rep(i, 0, m) cin >> p[i];

    mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

    vector<int> sum(m);
    vector<int> where(n);
    rep(i,0,n) where[i] = rng() % m;
    rep(i,0,n) sum[where[i]] += s[i];

    vector<int> q(n);
    iota(all(q), 0);
    for (;;) {
        bool ok = true;
        shuffle(all(q), rng);
        for (auto i : q) {
            rep(j, 0, m) {
                if (where[i] == j) continue;
                if (1ll * p[j] * sum[where[i]] > 1ll * p[where[i]] * (sum[j] + s[i])) {
                    sum[where[i]] -= s[i];
                    sum[j] += s[i];
                    where[i] = j;
                    ok = false;
                    break;
                }
            }
        }
        if (ok) break;
    }

    vector<vector<int>> ans(m);
    rep(i, 0, n) ans[where[i]].push_back(i);
    rep(i, 0, m) {
        cout << size(ans[i]);
        for (int x : ans[i]) cout << ' ' << x + 1;
        cout << '\n';
    }



    return 0;
}