#include <iostream>
#include <algorithm>
#include <vector>

#define rep(i, a, b) for (int i = a; i < b; i++)
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

using vi = vector<int>;

vi Z(const string &S) {
    vi z(sz(S));
    int l = -1, r = -1;
    rep(i, 1, sz(S)) {
        z[i] = i >= r ? 0 : min(r - i, z[i - l]);
        while (i + z[i] < sz(S) && S[i + z[i]] == S[z[i]])
            z[i]++;
        if (i + z[i] > r)
            l = i, r = i + z[i];
    }
    return z;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    string s;
    cin >> s;

    vector <string> sa;
    rep(i, 0, sz(s)) sa.push_back(s.substr(i));
    sort(all(sa));

    int best = 1 + sz(s);
    rep(i, 1, sz(s)) {
        int lcp = 0;
        while (lcp < sz(sa[i]) && lcp < sz(sa[i - 1]) && sa[i][lcp] == sa[i - 1][lcp]) lcp++;
        if (lcp <= 1) continue;
        string cp = sa[i].substr(0, lcp);
        vi z = Z(cp + "#" + s);
        int non_overlapping = 0;
        rep(j, lcp + 1, sz(z)) if (z[j] == lcp)
            non_overlapping++, j += lcp - 1;
        best = min(best, lcp + sz(s) - (lcp - 1) * non_overlapping);
    }

    cout << best << endl;
}

