#include <algorithm>
#include <array>
#include <iostream>
#include <queue>
#include <tuple>
#include <vector>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(x) begin(x), end(x)

using namespace std;

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin.exceptions(cin.failbit);

    int n, k;
    cin >> n >> k;
    vector<array<int, 4>> a(n);
    rep(i, n) rep(j, 4) cin >> a[i][j], --a[i][j];
    vector dp(n, array<array<array<int, 3>, 4>, 21>());
    rep(i, n) rep(j, 4) rep(l, 21) dp[i][l][j].fill(1e9);
    queue<tuple<int, int, int, int>> q;
    rep(i, 4) q.emplace(0, 0, i, 1), dp[0][0][i][1] = 0;
    for (; size(q); q.pop()) {
        auto [u, t, p, d] = q.front();
        auto dist = dp[u][t][p][d];
        if (u == n-1) return cout << dist << '\n', 0;
        rep(dir, 3) {
            int tt = t + (dir != 1 && d != dir);
            if (tt > k) continue;
            int v = a[u][(p+dir+1)%4];
            if (v == -1) continue;
            int pp = find(all(a[v]), u) - begin(a[v]);
            if (dist + 1 < dp[v][tt][pp][dir]) {
                dp[v][tt][pp][dir] = dist + 1;
                q.emplace(v, tt, pp, dir);
            }
        }
    }
    cout << "impossible\n";
    return 0;
}
