#include <iostream>
#include <algorithm>
#include <numeric>
#include <stack>
#include <functional>

#define rep(i, a, b) for (int i = a; i < b; ++i)

using namespace std;
using vi = vector<int>;
using vvi = vector<vi>;

vi next_larger(const vi& a, bool nx, auto&& c) {
    vi ans(size(a), nx ? ssize(a) : -1);
    stack<int> st;
    rep(j, 0, ssize(a)) {
        int i = nx ? j : ssize(a) - j - 1;
        while (!st.empty() && c(a[st.top()], a[i]))
            ans[st.top()] = i, st.pop();
        st.push(i);
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int w, h, q, qw, qh; cin >> h >> w >> q;

    vector<string> M(h);
    for (auto &row : M) cin >> row;

    vvi ans(h+1, vi(w+3));

    vi c(w);
    rep(i, 0, h) {
        rep(j, 0, w) c[j] = M[i][j] == '#' ? 0 : c[j] + 1;
        vi p = next_larger(c, false, greater_equal()), n = next_larger(c, true, greater());
        rep(j, 0, w) {
            int v = c[j], l = j - p[j], r = n[j] - j;
            ans[v][1]++, ans[v][l+1]--, ans[v][r+1]--, ans[v][l+r+1]++;
        }
    }
    rep(_, 0, 2) rep(i, 1, h+1) rep(j, 1, w+1) ans[i][j] += ans[i][j-1];
    rep(j, 1, w+1) for (int i = h-1; i >= 0; --i) ans[i][j] += ans[i+1][j];
    rep(i, 0, q) {
        cin >> qh >> qw;
        cout << ans[qh][qw] << "\n";
    }
}
