#!/usr/bin/env python3
from collections import deque

n, k = [int(x) for x in input().split()]
adj = [[] for _ in range(n)]
for i in range(n):
    adj[i] = [int(x)-1 for x in input().split()]
    
if n == 1:
    print(0)
    exit()

inf = 10**9
div = 12*(k+1)
dist = [inf]*(12*(k+1)*n) #loc, nblinks, direction, free
# directions are numbered north, east, south, west
# turning right is +1, turning left is -1. 

q = deque([])
for i in range(4): 
    if adj[0][i] != -1:
        node = (adj[0][i], 0, i, 0)
        node_idx = adj[0][i]*div + 3*i + 1
        q.append(node)
        dist[node_idx] = 1
    
while len(q) > 0:
    loc, nblinkers, direction, free = q[0]; q.popleft()
    node_idx = loc*div+nblinkers*12+direction*3+free+1
    dcur = dist[node_idx]
    for idx, loc_new in enumerate(adj[loc]):
        if loc_new == -1: continue
        if idx == direction or idx%4 == (direction + free)%4: 
            nblinknew = nblinkers
        else: nblinknew = nblinkers+1
        if nblinknew > k: continue
        
        freenew = (idx - direction + 1)%4 - 1
        if freenew == 2: continue #u-turn
        
        new_direction = -1
        for i in range(4):
            if adj[loc_new][i] == loc:
                new_direction = i
                break
        new_direction = (2+new_direction)%4

        node_new_idx = loc_new*div + nblinknew*12 + new_direction*3 + freenew + 1
        if dist[node_new_idx] == inf:
            dist[node_new_idx] = dcur+1
            node_new = (loc_new, nblinknew, new_direction, freenew)
            q.append(node_new)
    

ans = min(dist[-div:])
if ans == inf:
    print("impossible")
else: print(ans)
