#!/usr/bin/env python3
# @EXPECTED_RESULTS@: ACCEPTED, TIME_LIMIT_EXCEEDED
from collections import Counter

MOD = 9000000000000007  # Closest "round" prime below 2^63/1009
word = input()
hash = dict()  # This dict is indexed using pairs, and grows fairly large, so that's likely too slow
for i in range(len(word)):
    curr = ord(word[i]) - ord('a')
    for j in range(i + 1, len(word)):
        curr = (curr * 1009 + ord(word[j]) - ord('a')) % MOD
        hash[(i, j + 1)] = curr

best = len(word) + 1
for part_len in range(2, len(word)):
    counter = Counter()
    next_pos = {}
    for i in range(len(word) - part_len + 1):
        h = hash[(i, i + part_len)]
        if h in next_pos and next_pos[h] > i: continue
        counter[h] += 1
        next_pos[h] = i + part_len
    for count in counter.values():
        score = len(word) - (part_len - 1) * (count - 1) + 1
        best = min(best, score)
print(best)
