// @EXPECTED_RESULTS@: RUN_TIME_ERROR, TIME_LIMIT_EXCEEDED, WRONG_ANSWER
#include <iostream>
#include <vector>
#include <string>
#include <utility>
#include <algorithm>

struct fenwick_tree{
	std::vector<int> tree;
	fenwick_tree(int n) : tree(n + 1) {}
	int query(int i){
		int total = 0;
		for(; i > 0; i -= (i & (-i))) total += tree[i];
		return total;
	}
	void increment(int i, int v) {for(; i < tree.size(); i += (i & (-i))) tree[i] += v;}
};

struct intervals{
	int n;
	fenwick_tree count, sum;
	intervals(int n_) : n(n_), count(n_), sum(n_) {}
	int query(int w) {return sum.query(n) - sum.query(w - 1) - (w - 1) * (count.query(n) - count.query(w - 1));}
	void update(int w, int sign) {count.increment(w, sign * 1); sum.increment(w, sign * w);}
};

int main(){
	int W, H, n;
	std::cin >> W >> H >> n;
	std::vector<std::string> board(H);
	for (int i = 0; i < H; ++i) std::cin >> board[i];
	std::vector<int> ws(n), hs(n), ans(n), ds(W);
	for (int i = 0; i < n; ++i) std::cin >> hs[i] >> ws[i];
	for (int i = 0; i < H; ++i){
		for (int j = 0; j < W; ++j) ds[j] = board[i][j] == '#' ? 0 : ds[j] + 1;
		std::vector<std::pair<bool, std::pair<int, int>>> events(W + n);
		for (int j = 0; j < W; ++j) events[j] = std::pair<bool, std::pair<int, int>>(true, std::pair<int, int>(j, ds[j]));
		for (int k = 0; k < n; ++k) events[W + k] = std::pair<bool, std::pair<int, int>>(false, std::pair<int, int>(k, hs[k]));
		std::sort(events.begin(), events.end(), [](std::pair<bool, std::pair<int, int>> e1, std::pair<bool, std::pair<int, int>> e2){
			return e1.second.second == e2.second.second ? e1.first || !e2.first : e1.second.second > e2.second.second;
		});
		std::vector<int> left(W, -1), right(W, -1);
		intervals is(W);
		for (std::pair<bool, std::pair<int, int>> e : events){
			int j = e.second.first;
			if (e.first){
				left[j] = right[j] = j;
				if (j > 0 && left[j - 1] >= 0){
					is.update(j - left[j - 1], -1);
					is.update(j - left[j - 1] + 1, 1);
					right[left[j - 1]] = j;
					left[j] = left[j - 1];
				}
				else is.update(1, 1);
				if (j + 1 < W && right[j + 1] >= 0){
					is.update(j - left[j] + 1, -1);
					is.update(right[j + 1] - j, -1);
					is.update(right[j + 1] - left[j] + 1, 1);
					left[right[j + 1]] = left[j];
					right[left[j]] = right[j + 1];
				}
			}
			else ans[j] += is.query(ws[j]);
		}
	}
	for (int i = 0; i < n; ++i) std::cout << ans[i] << std::endl;
    return 0;
}
