#!/usr/bin/env python3

# @EXPECTED_RESULTS@: RUN_TIME_ERROR, TIME_LIMIT_EXCEEDED, WRONG_ANSWER
# On my machine, this submission uses 3.5GB RAM, but on the CI, its output is simply cut off and it gives WA 🤷


class Intervals:
    def __init__(self, n):
        self.n = n
        self.boundary = [-1] * n

    def merge(self, i):
        lengths[i - self.boundary[i] + 1] -= 1
        lengths[self.boundary[i + 1] - i] -= 1
        lengths[self.boundary[i + 1] - self.boundary[i] + 1] += 1
        self.boundary[self.boundary[i + 1]], self.boundary[self.boundary[i]] = self.boundary[i], self.boundary[i + 1]

    def add(self, i):
        self.boundary[i] = i
        lengths[1] += 1
        if i < self.n - 1 and self.boundary[i + 1] != -1:
            self.merge(i)
        if i > 0 and self.boundary[i - 1] != -1:
            self.merge(i - 1)


lengths = []
r, c, q = map(int, input().split())
board = [input() for _ in range(r)]
heights = [0] * c
height_indices = [[] for _ in range(r + 1)]
for h in range(r):
    for w in range(c):
        heights[w] = heights[w] + 1 if board[h][w] == '.' else 0
        height_indices[heights[w]].append((h, w))
counts = [[0] * (c + 1) for _ in range(r + 1)]
lengths = [0] * (c + 1)
rows = [Intervals(c) for _ in range(r)]
for h in range(r - 1, -1, -1):
    for p in height_indices[h + 1]:
        rows[p[0]].add(p[1])
    count, sum = 0, 0
    for w in range(c, 0, -1):
        counts[h + 1][w] = sum + count + lengths[w]
        count += lengths[w]
        sum += count
for _ in range(q):
    h, w = map(int, input().split())
    print(counts[h][w])
