// @EXPECTED_RESULTS@: RUN_TIME_ERROR, TIME_LIMIT_EXCEEDED, WRONG_ANSWER

// TODO: figure out where the WA is coming from

#include <iostream>
#include <vector>
#include <functional>
#include <algorithm>
#include <numeric>
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) begin(x), end(x)

using namespace std;
using ll = long long;

void solve() {
    int n; cin >> n;
    vector<ll> a(n);
    for (auto& x : a) cin >> x;

    vector<ll> p(n+1);
    partial_sum(all(a), p.begin()+1);

    // less memory than vector<vector<char>>
    vector cached(n, vector(n, false));
    vector memo(n, vector(n, false));

    function<bool(int l, int r)> solve = [&](int l, int r) -> bool {
        if (l > r) return true;
        if (cached[l][r]) return memo[l][r];
        cached[l][r] = true;
        if ((p[r+1] - p[l]) * n > p[n] * (r - l + 1)) return memo[l][r] = false;
        return memo[l][r] = solve(l, r - 1) || solve(l + 1, r);
    };

    if (!solve(0, n-1)) { cout << "impossible\n"; return; }
    vector<int> seq;
    function<void(int, int)> reconstruct = [&](int l, int r) {
        if (l > r) return;
        if (solve(l, r - 1)) { seq.push_back(r); reconstruct(l, r - 1); }
        else { seq.push_back(l); reconstruct(l + 1, r); }
    };
    reconstruct(0, n-1);
    ranges::reverse(seq);
    rep(i, n) cout << seq[i]+1 << " \n"[i == n-1];
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    solve();
}
