#!/usr/bin/env pypy3


from collections import defaultdict


def compute_sequence(nums):
    n = len(nums)

    parents = defaultdict(lambda: None)
    parents[(0, n - 1)] = (0, 0)
    stack = [(0, n - 1)]

    found = False

    cumsums = [0] * (n + 1)
    total = 0
    for i in range(n):
        total += nums[i]
        cumsums[i + 1] = total

    def is_valid(i, j):
        return (cumsums[j + 1] - cumsums[i]) * n <= total * (j - i + 1)

    # Do a dfs through the grid
    while stack:
        l, r = stack.pop()

        if l == r:
            found = True
            break

        if l + 1 < n and is_valid(l + 1, r) and parents[(l + 1, r)] is None:
            stack.append((l + 1, r))
            parents[(l + 1, r)] = (l, r)
        if r - 1 >= 0 and is_valid(l, r - 1) and parents[(l, r - 1)] is None:
            stack.append((l, r - 1))
            parents[(l, r - 1)] = (l, r)

    if found:
        order = [l + 1]

        while l > 0 or r < n - 1:
            nl, nr = parents[(l, r)]

            order.append(nl * (nl != l) + nr * (nl == l) + 1)

            l, r = nl, nr

        print(*order)
    else:
        print("impossible")


def main():
    _ = input()
    nums = [int(x) for x in input().split()]

    compute_sequence(nums)

    pass


if __name__ == "__main__":
    main()
