#include <iostream>
#include <string>
#include <algorithm>

using namespace std;


// https://stackoverflow.com/a/22489127
// returns count of non-overlapping occurrences of 'sub' in 'str'
int count_substring(const string& str, const string& sub) {
    if (sub.length() == 0) return 0;
    int count = 0;
    for (size_t offset = str.find(sub); offset != string::npos; offset = str.find(sub, offset + sub.length())) {
        ++count;
    }
    return count;
}

int main() {
    string word;
    cin >> word;

    int best = word.length() + 1;
    for (int part_len = 2; part_len < word.length(); part_len++) {
        for (int i = 0; i <= word.length() - part_len; i++) {
            string part = word.substr(i, part_len);
            int count = count_substring(word, part);
            int score = word.length() - (part_len - 1) * (count - 1) + 1;
            best = min(best, score);
        }
    }

    cout << best << endl;
}
