#!/usr/bin/env python3
n, k = map(int, input().split())
orders = list(input().split())  # List of cd
pinned = input().split()  # Mix of char and digit
d, c = input().split()  # digit, char

# Prove that all pinned 'd' have an 'c' on the other side.

ans = []
# If there are Xd with X!=c, then turn all d cards.
flip_d = False
for o in orders:
    if o[1] == d and o[0] != c:
        flip_d = True
if flip_d:
    for i in range(len(pinned)):
        if pinned[i] == d:
            ans.append(i + 1)

# Build a graph with 0-9, A-Z left, and all 'good' (non-Y1) on the right.
n = 2 + 10 + 26 + 260
s = 0
t = 1


def id(x):
    if len(x) == 1:
        if x.isdigit():
            return 2 + int(x)
        else:
            return 12 + ord(x) - ord("A")
    else:
        return 38 + 10 * (ord(x[0]) - ord("A")) + int(x[1])


g = [[] for _ in range(n)]
for i in "0123456789":
    g[s].append((id(i), pinned.count(i), 0))
    g[id(i)].append((s, 0, 0))
for i in "ABCDEFGHIJKLMNOPQRSTUVWXYZ":
    g[s].append((id(i), pinned.count(i), 0))
    g[id(i)].append((s, 0, 0))
for i in "0123456789":
    for j in "ABCDEFGHIJKLMNOPQRSTUVWXYZ":
        if i == d and j != c:
            continue
        ji = j + i
        g[id(ji)].append((t, orders.count(ji), 0))
        g[t].append((id(ji), 0, 0))

        g[id(i)].append((id(ji), 1000, 0))
        g[id(j)].append((id(ji), 1000, 0))
        g[id(ji)].append((id(i), 0, 0))
        g[id(ji)].append((id(j), 0, 0))


# Dinic flow algorithm
# Thanks, Copilot.
def flow(s, t):
    flow = 0
    while True:
        q = [s]
        parent = [-1] * n
        parent[s] = s
        while q and parent[t] == -1:
            u = q.pop()
            for v, cap, flw in g[u]:
                if parent[v] == -1 and flw < cap:
                    parent[v] = u
                    q.append(v)
        if parent[t] == -1:
            break
        flow += 1
        v = t
        while v != s:
            u = parent[v]
            # BUG: This only does at most unit flow over each edge.
            for i, (x, cap, f) in enumerate(g[u]):
                if x == v:
                    g[u][i] = (x, cap, 0 + 1)
                    break
            for i, (x, cap, f) in enumerate(g[v]):
                if x == u:
                    g[v][i] = (x, cap, 0 - 1)
                    break
            v = u
    return flow


f = flow(s, t)

if f < len(pinned):
    print("false")
    exit()

# If there are cY with Y!=d, then turn all non-c cards.
for y in "ABCDEFGHIJKLMNOPQRSTUVWXYZ":
    if y == c:
        continue
    flip_y = False
    for o in orders:
        if o[0] == y and o[1] == d:
            flip_y = True
    if flip_y:
        for i in range(len(pinned)):
            if pinned[i] == y:
                ans.append(i + 1)
if len(ans) == 0:
    print("true")
else:
    print(len(ans))
    print(*ans)
