#include <iostream>
#include <vector>
#include <algorithm>
#include <limits>

#define ll long long

using namespace std;

int main() {
    ll n, m;
    cin >> n >> m;
    vector<ll> c(n);
    for (ll i = 0; i < n; ++i) {
        cin >> c[i];
    }

    vector<pair<ll, ll>> se(m);
    for (ll i = 0; i < m; ++i) {
        ll x, y;
        cin >> x >> y;
        se[i] = {x - 1, y - 1}; // Convert to 0-based index
    }

    sort(se.begin(), se.end(), [](const pair<ll, ll>& a, const pair<ll, ll>& b) {
        return (a.second < b.second) || (a.second == b.second && a.first > b.first);
    });

    // Only keep non-redundant intervals.
    vector<pair<ll, ll>> se2;
    se2.push_back(se[0]);
    for (size_t i = 1; i < se.size(); ++i) {
        ll s = se[i].first, e = se[i].second;
        if (s <= se2.back().first) {
            continue;
        }
        se2.push_back({s, e});
    }

    se = se2;
    se.push_back({n, n});
    ll ii = 0;

    vector<ll> dp(n, 0);
    ll best = 0;
    for (ll i = 0; i < n; ++i) {
        dp[i] = best + c[i];
        if (i == se[ii].second) {
            best = numeric_limits<ll>::max();
            for (ll j = se[ii].first; j <= se[ii].second; ++j) {
                best = min(best, dp[j]);
            }
            ii++;
        }
    }
    cout << best << endl;

    return 0;
}
