#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n, k;
    cin >> n >> k;
    vector<long long> travelDay(n), fare(n), period(k), days(k), cost(k);
    for(int i = 0; i < n; i++) {
        cin >> travelDay[i] >> fare[i];
    }
    for(int i = 0; i < k; i++) {
        cin >> period[i] >> days[i] >> cost[i];
    }

    // NOTE: This should TLE because lastride is recomputed via a scan each time.
    // Last ride on/before given day.
    // vector<long long> lastride(2000001, n - 1);
    // for(int i = 0; i < n - 1; i++) {
    //     for(long long d = travelDay[i]; d < travelDay[i + 1]; d++) lastride[d] = i;
    // }

    // Cost of everything before ride i.
    vector<long long> dp(n + 1, 10000000000L);
    dp[0] = 0;

    for(int i = 0; i < n; i++) {
        long long c = dp[i];
        // Pay for i+1:
        dp[i + 1] = min(dp[i + 1], c + fare[i]);
        // Try each of the discount cards, starting with rides[i].
        long long startday = travelDay[i];
        for(int j = 0; j < k; j++) {
            // Can do at most `days[j]` rides.
            int h                  = i + days[j];
            h                      = min(h, n);
            int last_day_of_period = startday + period[j] - 1;
            while(travelDay[h - 1] > last_day_of_period) --h;
            dp[h] = min(dp[h], c + cost[j]);
        }
    }
    cout << dp[n] << endl;
}
