#include <iostream>
#include <vector>
#include <algorithm>

#define ld long double

using namespace std;

vector<ld> p;
vector<vector<int>> g;
vector<bool> visited;

ld dfs(int u) {
    visited[u] = true;
    ld s = 1 - p[u];
    for (int v : g[u]) {
        if (!visited[v]) {
            s *= dfs(v);
        }
    }
    return s;
};

int main() {
    int n, m;
    cin >> n >> m;
    p = vector<ld>(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
    }

    g = vector<vector<int>>(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u -= 1;
        v -= 1;
        g[u].push_back(v);
    }

    visited = vector<bool>(n);

    ld max_s = 0;
    for (int r = 0; r < n; ++r) {
        fill(visited.begin(), visited.end(), false);
        max_s = max(max_s, dfs(r));
    }
    cout << max_s << endl;
}
