#!/usr/bin/env python3

""" Top-down recursive solution without memoization. (=  thore-rec.py without @cache)
"""

from bisect import bisect_left as floor_idx
import sys

n, k = map(int, input().split())
trips = tuple(tuple(map(int, input().split())) for _ in range(n))
dates = tuple(t[0] for t in trips)
fares = tuple(t[1] for t in trips)
passes = tuple(tuple(map(int, input().split())) for _ in range(k))

sys.setrecursionlimit(100000)


def cost(idx):
    """Returns the cheapest total cost for rides up to and including idx"""
    if idx < 0:
        return 0
    # case: pay normal fare for day idx
    prev_cost = cost(idx - 1)
    choices = [prev_cost + fares[idx]]
    # other cases: buy a pass
    for pidx, (days, rides, price) in enumerate(passes):
        earliest_free_idx = max(
            idx - rides + 1, floor_idx(dates, dates[idx] - days + 1)
        )
        prev_cost = cost(earliest_free_idx - 1)
        choices.append(prev_cost + price)
    # find min-cost choice
    return min(choices)


print(cost(n - 1))
