
#include <iostream>
#include <algorithm>
#include <vector>
#include <numeric>

#define rep(i, a, b) for (int i = a; i < b; i++)
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

using vi = vector<int>;

vi Z(const string& S) {
    vi z(sz(S));
    int l = -1, r = -1;
    rep(i,1,sz(S)) {
        z[i] = i >= r ? 0 : min(r - i, z[i - l]);
        while (i + z[i] < sz(S) && S[i + z[i]] == S[z[i]])
            z[i]++;
        if (i + z[i] > r)
            l = i, r = i + z[i];
    }
    return z;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    string s;
    cin >> s;

    int best = 1 + sz(s);

    rep(i, 0, sz(s)) {
        rep(j, i + 2, sz(s)+1) {
            string cp = s.substr(i, j - i);
            int w = sz(cp);
            if (w <= 1) continue;
            vi z = Z(cp + "#" + s);
            int non_overlapping = 0;
            rep(j, w + 1, sz(z)) if (z[j] == w)
                non_overlapping++, j += w - 1;
            best = min(best, w + sz(s) - (w-1) * non_overlapping);
        }
    }

    cout << best << endl;
}

