#include <iostream>
#include <vector>
#include <functional>
#include <numeric>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma")

#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) begin(x), end(x)

using namespace std;
using ll = long long;

int main() {
    cin.tie(0)->sync_with_stdio(0);

    int n; cin >> n;
    vector<ll> a(n);
    for (auto& x : a) cin >> x;

    vector<ll> p(n+1);
    partial_sum(all(a), p.begin()+1);

    vector<int> seq;
    function<int(int l, int r)> solve = [&](int l, int r) -> char {
        if (l > r) return true;
        if ((p[r+1] - p[l]) * n > p[n] * (r - l + 1)) return false;
        if (solve(l, r - 1)) { seq.push_back(r); return true; }
        if (solve(l + 1, r)) { seq.push_back(l); return true; }
        return false;
    };

    if (!solve(0, n-1)) { cout << "impossible\n"; return 0; }
    rep(i, n) cout << seq[i]+1 << " \n"[i == n-1];
}
