#include <iostream>
#include <algorithm>
#include <vector>
#include <climits>

#define rep(i, a, b) for (int i = a; i < b; ++i)

using namespace std;
using vi = vector<int>;
using vvi = vector<vi>;

template <typename T>
auto transpose(const vector<T>& a) {
    vector b(size(a[0]), T(size(a), 0));
    rep(i, 0, size(a)) rep(j, 0, size(a[0])) b[j][i] = a[i][j];
    return b;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int w, h, q, qw, qh; cin >> h >> w >> q;

    vector<string> M(h);
    for (auto &row : M) cin >> row;

    bool transposed = h < w;
    if (transposed) swap(h, w), M = transpose(M);

    vvi ans(h+1, vi(w+1));

    vi c(w);
    rep(i, 0, h) {
        rep(j, 0, w) {
            c[j]++;
            if (M[i][j] == '#') c[j] = 0;
        }
        rep(j, 0, w) {
            if (c[j] == 0) continue;
            int mn = INT_MAX;
            for (int k = j; k < w && c[k] > 0; ++k) {
                mn = min(mn, c[k]);
                ++ans[mn][k-j+1];
            }
        }
    }

    rep(j, 1, w+1) for (int i = h-1; i >= 0; --i) ans[i][j] += ans[i+1][j];
    rep(i, 0, q) {
        cin >> qh >> qw;
        cout << (transposed ? ans[qw][qh] : ans[qh][qw]) << "\n";
    }
}
