#include <cassert>
#include <iostream>
#include <queue>
#include <vector>

using vi  = std::vector<int>;
using vvi = std::vector<vi>;

struct dist {
    int dist, turns, prevDir;
};

int getIncomingDirection(int u, int v, const vvi &adj) {
    for (int d = 0; d < 4; d++)
        if (adj[v][d] == u)
            return d;
    assert(false);
}

int main() {
    int n, k;
    std::cin >> n >> k;
    const int s = 1, t = n;

    if (s == t) {
        std::cout << 0 << std::endl;
        return 0;
    }

    vvi adj(n+1, vi(4));
    for (int u = 1; u <= n; u++) {
        for (int d = 0; d < 4; d++) {
            int v;
            std::cin >> v;
            adj[u][d] = v;
        }
    }

    std::queue<int> queue;
    std::vector<dist> status(n+1, dist{-1, -1, -1});
    status[s] = {0, 0, -1};
    for (int d = 0; d < 4; d++) {
        const int v = adj[s][d];
        if (!v) continue;
        queue.push(v);
        status[v] = {1, 0, getIncomingDirection(s, v, adj)};
    }

    while (!queue.empty()) {
        const int u = queue.front(); queue.pop();
        const auto &us = status[u];
        if (u == t) break;

        for (int d = 0; d < 4; d++) {
            const int v = adj[u][d];
            auto &vs = status[v];
            if (!v || vs.dist >= 0) continue;
            assert(d != us.prevDir);

            queue.push(v);
            vs = {
                us.dist + 1,
                us.turns + (d % 2 != us.prevDir % 2),
                getIncomingDirection(u, v, adj)
            };
        }
    }

    const auto &ts = status[t];
    if (ts.dist >= 0 && ts.turns <= k)
        std::cout << ts.dist << std::endl;
    else
        std::cout << "impossible" << std::endl;
}
