#include <cassert>
#include <iostream>
#include <queue>
#include <vector>

using vi  = std::vector<int>;
using vvi = std::vector<vi>;

int main() {
    int n, k;
    std::cin >> n >> k;
    const int s = 1, t = n;

    vvi adj(n+1);
    for (int u = 1; u <= n; u++) {
        for (int d = 0; d < 4; d++) {
            int v;
            std::cin >> v;
            if (v) adj[u].push_back(v);
        }
    }

    std::queue<int> queue;
    std::vector<int> dist(n+1, -1);
    queue.push(s);
    dist[s] = 0;

    while (!queue.empty()) {
        const int u = queue.front(); queue.pop();
        if (u == t) break;
        for (const int v : adj[u]) {
            if (dist[v] == -1) {
                dist[v] = dist[u] + 1;
                queue.push(v);
            }
        }
    }

    if (dist[t] >= 0)
        std::cout << dist[t] << std::endl;
    else
        std::cout << "impossible" << std::endl;
}
