#!/usr/bin/env python3
import sys


""" Solves problem backwards (which is good). When both lo++ and hi-- would be
    valid (in the sense of not creating overflow in a[++lo] ... a[hi] nor in
    a[lo]..a[--hi]) it greedily chooses to reduce hi if a[hi] > a[lo]. Intuitively,
    this "gets rid of more" liquid than the alternative; a sloppy (and false)
    exchange argument support this (misleading) intuition.

    Fails on interesting instances where a[lo] == a[hi], including

        5
        1 0 0 1 0

    when lo == 1, hi == 4
"""

n = int(input())
a = list(map(int, input().split()))

basin = total = sum(a)

lo = 0
hi = n - 1
result = []
while lo < hi:
    if a[lo] < a[hi]:
        basin -= a[hi]
        result.append(hi + 1)
        hi -= 1
    else:
        basin -= a[lo]
        result.append(lo + 1)
        lo += 1
    if total * (hi - lo + 1) < basin * n:
        print("impossible")
        sys.exit(0)
        break
print(lo + 1, *reversed(result))
