#!/usr/bin/env python3

""" Consider only the ticket with longest validity.

    Otherise, this is just the top-down recursive solution with 
    memoization (using Python's functools.lru_cache).
"""

from bisect import bisect_left as floor_idx
from functools import lru_cache
import sys

n, k = map(int, input().split())
trips = tuple(tuple(map(int, input().split())) for _ in range(n))
dates = tuple(t[0] for t in trips)
fares = tuple(t[1] for t in trips)
passes = list(tuple(map(int, input().split())) for _ in range(k))
passes.sort(key=lambda t: -t[1])
passes = passes[0:1]

sys.setrecursionlimit(100000)
@lru_cache(maxsize=100000)
def cost(idx):
    """Returns the cheapest total cost for rides up to and including idx"""
    if idx < 0:
        return 0
    choices = [cost(idx - 1) + fares[idx]]
    for days, rides, price in passes:
        earliest_free_idx = max(
            idx - rides + 1, floor_idx(dates, dates[idx] - days + 1)
        )
        choices.append(cost(earliest_free_idx - 1) + price)
    return min(choices)


print(cost(n - 1))

