#!/usr/bin/env python3
from collections import Counter


def m_pair(i, j): return 5000 * i + j


MOD = 2 ** 42 + 1
n = len(word := input())
hash = [0] * (5001 * 5001)  # Rolling hash ftw!
for i in range(n):
    curr = ord(word[i]) - ord('a') + 42
    for j in range(i + 1, n):
        curr = (curr * 26 + ord(word[j]) - ord('a')) % MOD
        hash[m_pair(i, j + 1)] = curr

best = n + 1
for part_len in range(2, n):
    counter = Counter()
    next_pos = Counter()
    for i in range(n - part_len + 1):
        h = hash[m_pair(i, i + part_len)]
        if next_pos[h] > i: continue
        counter[h] += 1
        next_pos[h] = i + part_len
    for count in counter.values():
        best = min(best, n - (part_len - 1) * (count - 1) + 1)
print(best)
