#!/usr/bin/env python3
import sys

sys.setrecursionlimit(10**6)

n, m = map(int, input().split())
p = list(map(float, input().split()))
g = [[] for _ in range(n)]
for _ in range(m):
    u, v = map(int, input().split())
    u -= 1
    v -= 1
    g[u].append(v)

visited = [False] * n


# Find a leaf node or 'deepest' cycle and return its probability.
# This fails, because the leaf component may not actually be a cycle.
def dfs(u):
    visited[u] = True
    s = 1 - p[u]
    if len(g[u]) == 0:
        return (s, None)
    v = g[u][0]
    if visited[v]:
        return (s, v)
    (ss, v) = dfs(v)
    if v is None:
        return (ss, None)
    if v == u:
        return (s * ss, None)
    return (s * ss, v)


max_s = 0
for r in range(n):
    if visited[r]:
        continue
    max_s = max(max_s, dfs(r)[0])
print(max_s)
