#include <algorithm>
#include <array>
#include <bitset>
#include <cassert>
#include <charconv>
#include <cstring>
#include <fstream>
#include <functional>
#include <iomanip>
#include <iostream>
#include <limits>
#include <map>
#include <optional>
#include <random>
#include <set>
#include <stdexcept>
#include <string>
#include <string_view>
#include <type_traits>
#include <unordered_map>
#include <utility>
#include <variant>
#include <vector>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> ii;
typedef vector<ll> vi;
typedef vector<vi> vvi;
typedef vector<ii> vii;

#define x first
#define y second
#define pb push_back
#define eb emplace_back
#define rep(i,a,b) for(auto i=(a); i<(b); ++i)
#define REP(i,n) rep(i,0,n)
#define all(v) (v).begin(), (v).end()
#define rs resize
#define DBG(x) cerr << __LINE__ << ": " << #x << " = " << (x) << endl

const ld PI = acos(-1.0);
template<class T> using min_queue =
priority_queue<T, vector<T>, greater<T>>;
template<class T> int sz(const T &x) {
    return (int) x.size(); // copy the ampersand(&)!
}

// START OF ACTUAL PROGRAM, START READING HERE

void run() {
	// This part is copied from accepted/reinier.cpp
	string s;
	cin >> s;
	ll n = s.size();

	vvi A(n+1, vi(n+1)), B(n+1, vi(n+1)), C(n+1, vi(n+1));
	for (ll i = n; i >= 0; i--) {
		for (ll j = 0; j <= n; j++) {
			if (i == n) {
				A[i][j] = i;
				B[i][j] = i;
				C[i][j] = -1;
			} else if (j == 0) {
				A[i][j] = i+1;
				B[i][j] = i+1;
			} else {
				A[i][j] = A[i][j-1];
				while (A[i][j] < n && (A[i][j]+j-1 >= n || s[A[i][j]+j-1] != s[i+j-1])) {
					A[i][j] = A[A[i][j]][j-1];
				}
				B[i][j] = B[i][j-1];
				while (B[i][j] < n &&
						(B[i][j] < i+j || B[i][j]+j-1 >= n || s[B[i][j]+j-1] != s[i+j-1])) {
					B[i][j] = A[B[i][j]][j-1];
				}
			}
			C[i][j] = C[B[i][j]][j] + 1;
		}
	}
	
	// Here starts the WA part
	ll lowerj = 1;
	ll upperj = n;
	ll res = n+1;
	while (upperj - lowerj > 1) {
		ll m1 = (2*lowerj+upperj+1)/3;
		ll m2 = (lowerj+2*upperj+1)/3;
		
		ll s1 = n+1, s2 = n+1;
		for (ll i = 0; i+m1-1 < n; i++) {
			s1 = min(s1, n+1-(C[i][m1]-1)*(m1-1));
		}
		for (ll i = 0; i+m2-1 < n; i++) {
			s2 = min(s2, n+1-(C[i][m2]-1)*(m2-1));
		}
		res = min(res, min(s1, s2));
		if (s1 < s2) {
			upperj = m2;	
		} else {
			lowerj = m1;
		}
	}
	
	cout << res << endl;
}

signed main() {
    // DON'T MIX "scanf" and "cin"!
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout << fixed << setprecision(20);
    run();
    return 0;
}
