#include <iostream>
#include <vector>
#include <functional>
#include <algorithm>
#include <numeric>
#include <deque>
#include <optional>
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) begin(x), end(x)

using namespace std;
using ll = long long;

struct avg {
    ll sum, cnt;
    avg() : sum(0), cnt(0) {}
    avg(ll sum) : sum(sum), cnt(1) {}
    avg(ll sum, ll cnt) : sum(sum), cnt(cnt) {}
    auto operator<=>(const avg& o) const {
        return sum * o.cnt <=> cnt * o.sum;
    }
    auto operator+(const avg& o) const {
        return avg{sum + o.sum, cnt + o.cnt};
    }
    auto operator+=(const avg& o) {
        return *this = *this + o;
    }
    auto operator-(const avg& o) const {
        return avg{sum - o.sum, cnt - o.cnt};
    }
    auto operator-=(const avg& o) {
        return *this = *this - o;
    }
};



int main() {
    cin.tie(0)->sync_with_stdio(0);

    int n; cin >> n;
    deque<ll> a(n);
    for (auto& x : a) cin >> x;

    auto greedy = [&](deque<ll> a) -> optional<vector<ll>> {
        vector<ll> seq;
        avg target{reduce(all(a)), n};
        avg cur = target;

        int l = 0, r = n-1;
        while (!a.empty()) {
            int sz = a.size();
            while (!a.empty() && cur-a.front() <= target) {
                cur -= a.front();
                seq.push_back(l++);
                a.pop_front();
            }
            while (!a.empty() && cur-a.back() <= target) {
                cur -= a.back();
                seq.push_back(r--);
                a.pop_back();
            }
            if (sz == a.size()) return nullopt;
        }
        ranges::reverse(seq);
        return seq;
    };

    auto seq = greedy(a);
    if (!seq) {
        ranges::reverse(a);
        seq = greedy(a);
        if (seq) ranges::reverse(*seq);
    }
    if (!seq) {
        cout << "impossible\n";
        return 0;
    }
    rep(i, n) cout << (*seq)[i]+1 << " \n"[i == n-1];
}
